
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InvoicesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        invoice_no: data.invoice_no
        ||
        null
            ,
            
        issued_at: data.issued_at
        ||
        null
            ,
            
        due_at: data.due_at
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        subtotal: data.subtotal
        ||
        null
            ,
            
        vat_rate: data.vat_rate
        ||
        null
            ,
            
        vat_amount: data.vat_amount
        ||
        null
            ,
            
        total: data.total
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await invoices.setCompany( data.company || null, {
            transaction,
        });
        
        await invoices.setCustomer( data.customer || null, {
            transaction,
        });
        
        await invoices.setOrder( data.order || null, {
            transaction,
        });
        

        

        

        return invoices;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const invoicesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                invoice_no: item.invoice_no
            ||
            null
            ,
            
                issued_at: item.issued_at
            ||
            null
            ,
            
                due_at: item.due_at
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                subtotal: item.subtotal
            ||
            null
            ,
            
                vat_rate: item.vat_rate
            ||
            null
            ,
            
                vat_amount: item.vat_amount
            ||
            null
            ,
            
                total: item.total
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const invoices = await db.invoices.bulkCreate(invoicesData, { transaction });

        // For each item created, replace relation files
        

        return invoices;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const invoices = await db.invoices.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.invoice_no !== undefined) updatePayload.invoice_no = data.invoice_no;
        
        
        if (data.issued_at !== undefined) updatePayload.issued_at = data.issued_at;
        
        
        if (data.due_at !== undefined) updatePayload.due_at = data.due_at;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.subtotal !== undefined) updatePayload.subtotal = data.subtotal;
        
        
        if (data.vat_rate !== undefined) updatePayload.vat_rate = data.vat_rate;
        
        
        if (data.vat_amount !== undefined) updatePayload.vat_amount = data.vat_amount;
        
        
        if (data.total !== undefined) updatePayload.total = data.total;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await invoices.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await invoices.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.customer !== undefined) {
            await invoices.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        
        if (data.order !== undefined) {
            await invoices.setOrder(
              
              data.order,
              
              { transaction }
            );
        }
        

        
        

        

        return invoices;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of invoices) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of invoices) {
                await record.destroy({transaction});
            }
        });


        return invoices;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findByPk(id, options);

        await invoices.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await invoices.destroy({
            transaction
        });

        return invoices;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findOne(
            { where },
            { transaction },
        );

        if (!invoices) {
            return invoices;
        }

        const output = invoices.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.invoice_lines_invoice = await invoices.getInvoice_lines_invoice({
            transaction
        });
        
        
        output.payments_invoice = await invoices.getPayments_invoice({
            transaction
        });
        
        
        
        
        
        
        
        output.company = await invoices.getCompany({
            transaction
        });
        
        
        output.customer = await invoices.getCustomer({
            transaction
        });
        
        
        output.order = await invoices.getOrder({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.orders,
        as: 'order',
        
        where: filter.order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_no: {
                [Op.or]: filter.order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.invoice_no) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'invoice_no',
                        filter.invoice_no,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.issued_atRange) {
                const [start, end] = filter.issued_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    issued_at: {
                    ...where.issued_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.due_atRange) {
                const [start, end] = filter.due_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.subtotalRange) {
                const [start, end] = filter.subtotalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    subtotal: {
                    ...where.subtotal,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    subtotal: {
                    ...where.subtotal,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.vat_rateRange) {
                const [start, end] = filter.vat_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.vat_amountRange) {
                const [start, end] = filter.vat_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    vat_amount: {
                    ...where.vat_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    vat_amount: {
                    ...where.vat_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.totalRange) {
                const [start, end] = filter.totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total: {
                    ...where.total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total: {
                    ...where.total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.invoices.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'invoices',
                        'invoice_no',
                        query,
                    ),
                ],
            };
        }

        const records = await db.invoices.findAll({
            attributes: [ 'id', 'invoice_no' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['invoice_no', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.invoice_no,
        }));
    }

    
};

